'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
    return;
  }

  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}

var highlightClassName = 'react-highlight';
var styles = "\n  .".concat(highlightClassName, " {\n    background: #f8ffb4;\n    transition: 0.5s ease-in-out;\n  }\n");
var styleSheet = document.createElement("style");
styleSheet.type = "text/css";
styleSheet.innerText = styles;
document.head.appendChild(styleSheet);

var ChangeHighlight = (function (_ref) {
  var children = _ref.children;

  var _useState = React.useState(),
      _useState2 = _slicedToArray(_useState, 2),
      myChildren = _useState2[0],
      setMyChildren = _useState2[1];

  var changedElementsList = new Set();

  var showHighlight = function showHighlight(element) {
    var showAfter = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 100;
    var hideAfter = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 1000;
    setTimeout(function () {
      if (!element.ref.current.className.includes(highlightClassName)) {
        element.ref.current.className += ' ' + highlightClassName;
        var classNames = element.ref.current.className;
        setTimeout(function () {
          element.ref.current.className = classNames.substr(0, classNames.indexOf(highlightClassName)).trim();
        }, hideAfter);
      }
    }, showAfter);
  };

  React.useEffect(function () {
    var firstTime = true;

    if (children) {
      if (!myChildren && firstTime) {
        setMyChildren(children);
        firstTime = false;
      } else {
        React__default.Children.map(children, function (newChild) {
          React__default.Children.map(myChildren, function (oldChild) {
            if (newChild.type === oldChild.type) {
              if (newChild.props.children !== oldChild.props.children) {
                setMyChildren(children);

                if (newChild.ref) {
                  changedElementsList.add(newChild);
                  Array.from(changedElementsList).forEach(function (element) {
                    showHighlight(element);
                  });
                }
              }
            }
          });
          return newChild.props.children;
        });
      }
    }

    return function () {};
  });
  return React__default.createElement("div", null, children);
});

module.exports = ChangeHighlight;
